package com.cesanelli.lajusta.io;

import com.cesanelli.lajusta.io.models.Cart;
import com.cesanelli.lajusta.io.models.General;
import com.cesanelli.lajusta.io.models.News;
import com.cesanelli.lajusta.io.models.Producer;
import com.cesanelli.lajusta.io.models.Product;
import com.cesanelli.lajusta.io.models.Signup;
import com.cesanelli.lajusta.io.models.Token;
import com.cesanelli.lajusta.io.models.TokenBody;
import com.cesanelli.lajusta.io.models.User;

import java.util.ArrayList;

import retrofit2.Call;
import retrofit2.http.Body;
import retrofit2.http.GET;
import retrofit2.http.Header;
import retrofit2.http.POST;
import retrofit2.http.Path;

public interface ApiService {
    @GET("product")
    Call<ArrayList<Product>> getProducts();

    @GET("product/{id}")
    Call<Product> getProduct(@Path("id") int id);

    @GET("producer")
    Call<ArrayList<Producer>> getProducers();

    @GET("producer/{id}")
    Call<Producer> getProducer(@Path("id") int id);

    @POST("token/generate-token")
    Call<Token> login(@Body TokenBody body);

    @POST("user/signup")
    Call<User> signup(@Body Signup body);

    @GET("user/{id}")
    Call<User> getUser(@Path("id") int id, @Header("Authorization") String authHeader);

    @GET("news")
    Call<News> getNews();

    @POST("cart")
    Call<Cart> postCart(@Body Cart body, @Header("Authorization") String authHeader);

    @GET("general/active")
    Call<General> getNodes();

}
