package com.cesanelli.lajusta.ui;

import android.content.Context;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProvider;
import androidx.navigation.Navigation;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.cesanelli.lajusta.R;
import com.cesanelli.lajusta.io.ApiAdapter;
import com.cesanelli.lajusta.io.models.Image;
import com.cesanelli.lajusta.io.models.News;
import com.cesanelli.lajusta.io.models.NewsItem;
import com.cesanelli.lajusta.io.models.Producer;
import com.cesanelli.lajusta.ui.viewmodel.NewsListViewModel;
import com.cesanelli.lajusta.ui.viewmodel.ProducerListViewModel;
import com.cesanelli.lajusta.ui.viewmodel.ProducerViewModel;

import java.util.ArrayList;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

/**
 * A fragment representing a list of Items.
 */
public class NewsFragment extends Fragment {
    private NewsListViewModel newsListViewModel;

    public NewsFragment() {
    }

    public static NewsFragment newInstance() {
        NewsFragment fragment = new NewsFragment();
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        return inflater.inflate(R.layout.fragment_producers_list, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        newsListViewModel = new ViewModelProvider(getActivity()).get(NewsListViewModel.class);
        newsListViewModel.getNewsList().observe(getViewLifecycleOwner(), list ->{
            if (list != null) {
                RecyclerView recyclerView = (RecyclerView) view;
                recyclerView.setLayoutManager(new LinearLayoutManager(getContext()));
                recyclerView.setAdapter(new NewsRecyclerViewAdapter((ArrayList<NewsItem>) list));
            }
        });
    }
}