package com.cesanelli.lajusta.ui;

import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.recyclerview.widget.RecyclerView;

import com.cesanelli.lajusta.databinding.FragmentProductsBinding;
import com.cesanelli.lajusta.io.models.Product;

import java.util.ArrayList;

/**
 * {@link RecyclerView.Adapter} that can display a {@link Product}.
 * TODO: Replace the implementation with code for your data type.
 */
public class ProductsRecyclerViewAdapter extends RecyclerView.Adapter<ProductsRecyclerViewAdapter.ViewHolder> {

    private final ArrayList<Product> products;
    private OnProductListener onProductListener;


    public ProductsRecyclerViewAdapter(ArrayList<Product> products, OnProductListener onProductListener) {
        this.products = products;
        this.onProductListener = onProductListener;
    }

    @Override
    public ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        LayoutInflater layoutInflater = LayoutInflater.from(parent.getContext());
        FragmentProductsBinding fragmentProductsBinding = FragmentProductsBinding.inflate(layoutInflater, parent, false);
        return new ViewHolder(fragmentProductsBinding);
    }

    @Override
    public void onBindViewHolder(final ViewHolder holder, int position) {
        Product product = products.get(position);
        holder.fragmentProductsBinding.setProduct(product);
        holder.fragmentProductsBinding.setOnProductListener(onProductListener);
    }

    @Override
    public int getItemCount() {
        return products.size();
    }

    public interface OnProductListener {
        void onProductClick(Product product);

        void onProductAdd(Product product);
    }

    public class ViewHolder extends RecyclerView.ViewHolder {
        FragmentProductsBinding fragmentProductsBinding;

        public ViewHolder(FragmentProductsBinding binding) {
            super(binding.getRoot());
            fragmentProductsBinding = binding;
        }
    }
}