package com.cesanelli.lajusta.ui;

import android.os.Bundle;
import android.preference.PreferenceManager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProvider;
import androidx.navigation.Navigation;

import com.cesanelli.lajusta.R;
import com.cesanelli.lajusta.io.models.Cart;
import com.cesanelli.lajusta.ui.viewmodel.CartViewModel;

public class PurchaseFinalFragment extends Fragment {
    private CartViewModel cartViewModel;

    public PurchaseFinalFragment() {
        // Required empty public constructor
    }

    public static PurchaseFinalFragment newInstance(String param1, String param2) {
        PurchaseFinalFragment fragment = new PurchaseFinalFragment();
        return fragment;
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        Button btnSeguirComprando = view.findViewById(R.id.btnSeguirComprando);
        String jwt = PreferenceManager.getDefaultSharedPreferences(getContext()).getString("JWT", "");

        cartViewModel = new ViewModelProvider(getActivity()).get(CartViewModel.class);
        Cart cart = cartViewModel.getCart().getValue();
        if (cart != null && cart.getNode() != null) {
            TextView txtDescription = view.findViewById(R.id.txtDescription);
            StringBuilder sb = new StringBuilder();
            sb.append("¡Muchas gracias por su compra!\n\n");
            sb.append("Recuerde retirarlo en ");
            sb.append(cart.getNode().getNode().getAddress().toString()).append(" el ");
            sb.append(cart.getNode().getOpen());
            txtDescription.setText(sb.toString());
        }

        cartViewModel.restart();

        btnSeguirComprando.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Navigation.findNavController(v).navigate(R.id.nav_products);
            }
        });
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        return inflater.inflate(R.layout.fragment_final, container, false);
    }

}